/**
 * MyTour - jQuery plugin to create an easy virtual tour across any website.  
 * Copyright (c) 2012, Rogério Taques. 
 *
 * Licensed under MIT license:
 * http://www.opensource.org/licenses/mit-license.php
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this 
 * software and associated documentation files (the "Software"), to deal in the Software 
 * without restriction, including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons 
 * to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or 
 * substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @requires jQuery v1.2 or above
 * @version 1.0
 * @cat Plugins/UI 
 * @author Rogério Taques (rogerio@awin.com.br | http://awin.com.br)
 * @see http://code.google.com/p/jquery-mytour/
 */
!function($){"use strict";function _autoplay(options){stepCurrent<stepContainer.length-1&&setTimeout(function(){stepCurrent++,_autoplay(options)},options.timer),_play(options)}function _stop(options){stepCurrent=0,$("#my-tour-tooltip").fadeOut("fast"),$("#my-tour-overlay, #my-tour-shield").fadeOut("fast"),$(".my-tour-highlight").removeClass("my-tour-highlight"),centerWindow=Math.ceil($(window).height()/2),triggerOffset=Math.ceil(tourTrigger.offset().top-centerWindow),$("html, body").animate({scrollTop:triggerOffset},"fast"),options.onFinish&&"function"==typeof options.onFinish&&options.onFinish()}function _isFixed(obj){return"fixed"==$(obj).css("position")?!0:$(obj).parent().is("body")?!1:_isFixed($(obj).parent())}function _play(options){var o=options,tip=$(stepContainer[stepCurrent]),tipPos=null,nub=null,nubDim=null,el=null,elPos=null,elPosIndex=["bottom","top","right","left","none"],me=$("#my-tour-tooltip"),tipOffset=null,centerWindow=null,mytop=0,myleft=0,overlay=$("#my-tour-overlay, #my-tour-shield");$(".my-tour-highlight").length&&$(".my-tour-highlight").data("reset-background")&&($(".my-tour-highlight").css("background-color","inherit"),$(".my-tour-highlight").removeData("reset-background")),$(".my-tour-highlight").removeClass("my-tour-highlight"),o.beforePlay&&"function"==typeof o.beforePlay&&o.beforePlay(stepCurrent),o.debug&&console.log("Current Step: "+stepCurrent+" Steps Defined: "+stepContainer.length),tip.length&&(el=$(tip.data("id")),el.length?(overlay.fadeIn("fast"),me.fadeOut("fast",function(){switch(me.find("#my-tour-content").empty().append(tip.html()),me.find("#my-tour-button-bar").remove(),me.append(_button(o)),tipPos=tip.data("position")||"bottom",elPos=el.offset(),nub=me.find("#my-tour-tooltip-nub"),nubDim={width:nub.outerWidth()>0?nub.outerWidth():Math.abs(nub.width()),height:nub.outerHeight()>0?nub.outerHeight():Math.abs(nub.height())},"none"==tipPos?(mytop=$(window).height()/2-me.outerHeight()/2,myleft=$(window).width()/2-me.outerWidth()/2):"top"==tipPos||"bottom"==tipPos?(mytop="top"==tipPos?elPos.top-me.outerHeight()-nubDim.height/3*2:elPos.top+el.outerHeight()+nubDim.height/3*2+parseInt(el.css("margin-bottom"),10),"top"==tipPos&&0>mytop?(mytop=elPos.top+el.outerHeight()+nubDim.height/3*2+parseInt(el.css("margin-bottom"),10),tipPos="bottom"):"bottom"==tipPos&&mytop>$(window).height()&&(mytop=elPos.top-me.outerHeight()-nubDim.height/3*2,tipPos="top")):("left"==tipPos||"right"==tipPos)&&(myleft="left"==tipPos?elPos.left-nubDim.width/3*2-me.outerWidth():elPos.left+el.outerWidth()+nubDim.width/3*2,"left"==tipPos&&0>myleft?(myleft=elPos.left+el.outerWidth()+nubDim.width/3*2,tipPos="right"):"right"==tipPos&&myleft+me.outerWidth()>$(window).width()&&(myleft=elPos.left-nubDim.width/3*2-me.outerWidth(),tipPos="left")),nub.removeAttr("style"),nub.removeClass("top bottom left right none"),nub.addClass(tipPos),elPosIndex.indexOf(tipPos)){case 1:me.css({display:"block",top:mytop-10,left:elPos.left+el.outerWidth()/2-me.outerWidth()/2}).animate({top:"+=10"},150),nub.css({left:Math.ceil(me.outerWidth()/2)});break;case 2:me.css({display:"block",top:elPos.top-me.outerHeight()/2+el.outerHeight()/2,left:myleft+10}).animate({left:"-=10"},150),nub.css({top:Math.ceil(me.outerHeight()/2-nub.outerHeight()/2)});break;case 3:me.css({display:"block",top:elPos.top-Math.ceil(me.outerHeight()/2),left:myleft-10}).animate({left:"+=10"},150),nub.css({top:Math.ceil(me.outerHeight()/2),left:me.outerWidth()});break;case 4:me.css({display:"block",top:mytop-10,left:myleft}).animate({top:"+=10"},150),nub.css("display","none");break;default:me.css({display:"block",top:mytop+10,left:elPos.left+el.outerWidth()/2-me.outerWidth()/2}).animate({top:"-=10"},150),nub.css({left:Math.ceil(me.outerWidth()/2-nub.outerWidth()/2)})}if("top"==tipPos||"bottom"==tipPos){var diff=Math.ceil(me.offset().left+me.outerWidth()-$(window).width());diff>0&&(me.css({left:me.offset().left-diff}),nub.css({left:diff+parseInt(nub.css("left"),10)+20}))}_isFixed(el)||(centerWindow=Math.ceil($(window).height()/2),tipOffset=Math.ceil(me.offset().top-centerWindow),$("html, body").animate({scrollTop:tipOffset},"slow")),"none"!=tipPos&&(el.addClass("my-tour-highlight"),("rgba(0, 0, 0, 0)"==el.css("background-color")||"transparent"==el.css("background-color"))&&(el.data("reset-background",!0),el.css("background-color","rgba(255, 255, 255, 1)"))),me.fadeIn("fast")})):(stepCurrent+=1,_play(o))),o.afterPlay&&"function"==typeof o.afterPlay&&o.afterPlay(stepCurrent)}function _button(options){var o=options,prev=$('<a href="#"  id="my-tour-button-prev"></a>'),next=$('<a href="#"  id="my-tour-button-next"></a>'),start=$('<a href="#"  id="my-tour-button-start"></a>'),finish=$('<a href="#"  id="my-tour-button-finish"></a>'),steps=$('<select id="my-tour-dropdown-steps" ></select>'),div=$('<div id="my-tour-button-bar" ></div>');if(!o.autoPlay&&o.buttons.start&&(stepCurrent>0?start.click(function(e){e.preventDefault(),stepCurrent=0,_play(o)}):start.click(function(e){e.preventDefault()}).addClass("disabled"),start.html(o.buttons.start).appendTo(div)),!o.autoPlay&&o.buttons.prev&&(stepCurrent>0?prev.click(function(e){e.preventDefault(),stepCurrent-=1,_play(o)}):prev.click(function(e){e.preventDefault()}).addClass("disabled"),prev.html(o.buttons.prev).appendTo(div)),!o.autoPlay&&o.buttons.next&&(stepCurrent<stepContainer.length-1?next.click(function(e){e.preventDefault(),stepCurrent+=1,_play(o)}):next.click(function(e){e.preventDefault()}).addClass("disabled"),next.html(o.buttons.next).appendTo(div)),(!o.autoPlay&&o.buttons.finish||o.buttons.finish&&stepCurrent>=stepContainer.length-1)&&(finish.click(function(e){e.preventDefault(),stepCurrent=0,_stop(o)}),finish.html(o.buttons.finish).appendTo(div)),!o.autoPlay&&o.buttons.menu){var i=0,j=i+1;for(i in stepContainer)$(stepContainer[i].data("id")).length&&steps.append('<option value="'+i+'" '+(stepCurrent==i?'selected="selected"':"")+" >"+j++ +"</option>");steps.change(function(){stepCurrent=parseInt(this.value,10),_play(o)}).appendTo(div)}return div}var version="1.0.7",stepContainer=[],stepCurrent=0,tourTrigger=null,defaults={start:0,buttons:{next:"Next",prev:"Prev",start:"Start",finish:"Finish",menu:!0},autoPlay:!1,timer:5e3,steps:"#my-tour-steps",stepHolder:"li",onStart:null,onShow:null,beforePlay:null,afterPlay:null,onFinish:null,debug:!1},methods={version:function(){return this.each(function(){$(this).html(version)})},init:function(options){var o=$.extend(defaults,options);return this.each(function(){var t=$(this),s=$(o.steps+" > "+o.stepHolder),tip=$("<div />",{id:"my-tour-tooltip","class":"my-tour-tooltip"}),overlay=$("<div />",{id:"my-tour-overlay","class":"my-tour-overlay"}),shield=$("<div />",{id:"my-tour-shield","class":"my-tour-shield"}),i=0;s.hide();for(i in s)$($(s[i]).data("id")).length&&(stepContainer[stepContainer.length]=$(s[i]).clone()),$(s[i]).remove();$("body").append(overlay.hide()).append(shield.hide()).append(tip.hide()),tip.append($("<div />",{id:"my-tour-content"})).append($("<span/>",{id:"my-tour-tooltip-nub","class":"my-tour-tooltip-nub"})).append($("<div />",{id:"my-tour-button-bar"})),stepCurrent=parseInt(o.start||0,10),(stepCurrent>stepContainer.length||0>stepCurrent)&&(stepCurrent=0),t.click(function(e){e.preventDefault(),tourTrigger=t,o.onShow&&"function"==typeof o.onShow&&o.onShow(),_play(o)}),o.onStart&&"function"==typeof o.onStart&&o.onStart(),o.autoPlay&&(o.onShow&&"function"==typeof o.onShow&&o.onShow(),_autoplay(o))})}};$.fn.mytour=function(method){return methods[method]?methods[method].apply(this,Array.prototype.slice.call(arguments,1)):"object"!=typeof method&&method?void $.error("Method "+method+" does not exist on jQuery.mytour()"):methods.init.apply(this,arguments)}}(jQuery);